//////////////////////////////////////////////////
//// Exercice 2: Résolution numérique d'un problème d'advection
//////////////////////////////////////////////////

// Objectif résoudre l'EDP
// du/dt + v du/dx = 0

clear;

disp('Exercice 2')

// Fonction qui permet de definir les conditions initiales
function [y]=finitial(x)
x1=20;
x2=70;
h=1;
cen=45;
w=-0.01;
n=length(x);
y=zeros(1,n); // vecteur de n elements mis à 0
for i=1:n
    if (x(i)>= x1 & x(i)<=x2)
        y(i) = h*exp(w*(x(i) -cen)^2);
    end
end
endfunction

// Conditions et paramètres initiaux
p=0; q=100;         // Bornes de domaine
v=-0.5;             // Vitesse du fluide [m/s]
N= 101;             // Nombre d'échantillons
dx= (q-p)/(N-1);    // longueur de la discretisation spatiale
dt= 0.003;          // longueur d'un pas de temps temporel
x = p: dx : q;      // Discretisation spatiale entre p et q avec pas dx
u0=zeros(1,N);      // Vecteur pour les valeurs initiales de u
u=zeros(1,N);       // Vecteur pour les valeur de u
exactu=zeros(1,N);  // Vecteur pour les solutions exactes de u
u0=finitial(x);     // Insertion des conditions initiales
ntimesteps=100;     // nombre de pas de temps de simulation

// Algorithme
for n=1:ntimesteps

// TODO: init ?

    for i=1:N
        exactu(i)=finitial(x(i)-v*t); // Solution exacte
    end

    u0=[u0 u0(N)]; // Mise sous forme de Dirichlet (Conditions Limites)
    for i=1:N

        // TODO: calcul de u(i) ?

    end
    u0=u(1:N); // Recopie de u courant dans u0
end 

// plot of final result
plot(x,u(1:N),'r+',x,exactu) // Affichage de solution exacte vs solution numerique
xlabel('x [metres]')
ylabel('concentration u [kg/m]')

disp('Fin Exercice 2')
